<?php
include_once('../common/delegate.php');

// Start the session
session_start();

// Check if user is logged
if(!is_numeric($_SESSION['userId'])) {
	header("Location: ". SERVER_ROOT ."");
	exit();
}

if(!empty($_GET['print']) AND $_GET['print'] == true AND !empty($_GET['projectId']) AND !empty($_GET['startDate'])) {
	$print			=	true;
	$displayReports = true;
	$projectId		=	$_GET['projectId'];
	$userId			=	$_GET['userId'];
	$startDate		=	$_GET['startDate'];
	$endDate		=	$_GET['endDate'];
	
} else {
	$print = false;
}


if(!empty($_SESSION['projectReports']['projectId']) AND !(empty($_SESSION['projectReports']['startDate']))) {
	$displayReports = true;
	$projectId	=	$_SESSION['projectReports']['projectId'];
	$userId		=	$_SESSION['projectReports']['userId'];
	$startDate	=	$_SESSION['projectReports']['startDate'];
	$endDate	=	$_SESSION['projectReports']['endDate'];
	
	unset($_SESSION['projectReports']);
}

// Make new Delegate instance
$delegate = new Delegate();

// Load user as object, from SQL by id
$loggedUser = $delegate->getUserById($_SESSION['userId']);

// Check if logged user is admin
if($loggedUser->level < USER_LEVEL_ADMIN) {
	header("Location: ". SERVER_ROOT ."/daily/daily.php");
	exit();
}


if(is_object($_SESSION['tmpProjectReports'])) {
	$tmpProjectReports = $_SESSION['tmpProjectReports'];
	$_SESSION['tmpProjectReports'] = null;
	unset($_SESSION['tmpProjectReports']);	
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

        
        <meta http-equiv="pragma" content="no-cache" />
        <meta http-equiv="expires" content="0">
        <title>Project reports</title>
        <link rel="shortcut icon" href="<?=SERVER_ROOT?>/pontaj.ico" type="image/x-icon" />

        <?	if($print == true) { ?>
        	<link href="<?=SERVER_ROOT?>/assets/css/print.css" rel="stylesheet" type="text/css" />
        <?	} else { ?>
        	<link href="<?=SERVER_ROOT?>/assets/css/pontaj.css" rel="stylesheet" type="text/css" />
        <?	}	?>
        
        <link href="<?=SERVER_ROOT?>/assets/calendar/calendar-win2k-1.css" rel="stylesheet" type="text/css" />
        <script type="text/javascript" src="<?=SERVER_ROOT?>/assets/calendar/calendar.js"></script>
        <script type="text/javascript" src="<?=SERVER_ROOT?>/assets/calendar/lang/calendar-en.js"></script>

        <script type="text/javascript" src="<?=SERVER_ROOT?>/assets/calendar/calendar-setup.js"></script>
        <script type="text/javascript" src="<?=SERVER_ROOT?>/assets/javascript/general.js"></script>     
        <script language="JavaScript" type="text/javascript">            
            function pickPeriod(){
                
                var period = document.getElementById('period');
                var periodStart = document.getElementById('periodStart');
                var periodEnd = document.getElementById('periodEnd');
                switch(period.value){
                    case 'currentMonth':
                        var date = new Date()
                        date.setDate(1)
                        periodStart.value = date.getDate() + '/' + (date.getMonth() +1) + '/' + date.getFullYear()
                        
                        date.setMonth(date.getMonth() + 1)
                        date.setDate(date.getDate() - 1)
                        periodEnd.value = date.getDate() + '/' + (date.getMonth() +1) + '/' + date.getFullYear()
                        break;
                    case 'lastMonth':
                        var date = new Date();
                        date.setDate(1)
                        date.setMonth(date.getMonth() - 1)
                        periodStart.value = date.getDate() + '/' + (date.getMonth() +1) + '/' + date.getFullYear()
                        
                        date.setMonth(date.getMonth() + 1)
                        date.setDate(date.getDate() - 1)
                        periodEnd.value = date.getDate() + '/' + (date.getMonth() +1) + '/' + date.getFullYear()
                        break;
                        
                }
            }
        </script>
        
       <script language="JavaScript1.5" src="<?=SERVER_ROOT?>/assets/javascript/json2.js" type="text/javascript"></script>
       <script language="JavaScript" type="text/javascript">            
            
            var http = null;            
            http = getHTTPObject();
            
            /*
            You can not reuse the XMLHttpRequest in IE6. 
            To do that you have to use abort() method.
            See: 
                http://radio.javaranch.com/pascarello/2006/03/30/1143735438047.html
                http://keelypavan.blogspot.com/2006/03/reusing-xmlhttprequest-object-in-ie.html
                http://blogs.pathf.com/agileajax/2006/08/object_pooling_.html
                http://ajaxian.com/archives/reusing-xmlhttprequest-without-abort
                http://en.wikipedia.org/wiki/XMLHttpRequest
            */
            function getHTTPObject() {
                if(http == null){
                    //alert('Is null');
                    if (window.XMLHttpRequest) { // Mozilla, Safari,...

                        http = new XMLHttpRequest();
                        if (http.overrideMimeType) {
                            http.overrideMimeType('text/html');
                            //netscape.security.PrivilegeManager.enablePrivilege("UniversalPreferencesRead");
                        }
                    } else if (window.ActiveXObject) { // IE
                        try {
                            http = new ActiveXObject("Msxml2.XMLHTTP");
                        } catch (i) {
                            try {
                                http = new ActiveXObject("Microsoft.XMLHTTP");
                            } catch (i) {}
                        }
                    }
                }
                else{
                    //alert('Is NOT null');
                    http.abort()
                }
                return http;                
            }
            
            function debugObject(obj){
                for(var prop in obj){
                    alert(prop);
                    for(var subprop in obj[prop]){
                        alert(subprop);
                    }
                }
            }
            
            function call_angajati(){
                http = getHTTPObject();
                //alert('k');
                var url = '<?=SERVER_ROOT?>/common/employeesForProject.php?'
                
                //get selected project
                if (document.getElementById('projectId')){
                    var projectSelect = document.getElementById('projectId');
                    var projectId = projectSelect.options[projectSelect.selectedIndex].value;
                    //alert('Project is ' + projectSelect.options[projectSelect.selectedIndex].value);

                    var params = 'projectId='+projectId;

                    http.open("POST", url, true);
                    http.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded'); 
                    http.onreadystatechange = function() {
                        if (http.readyState == 4 && http.status == 200) {
                            var result = http.responseText;
                            //alert("heeyyyy");
                            //alert(result);
                            http.abort();


                            //clear employees select
                            var employeeSelect = document.getElementById('angajatId');
                            employeeSelect.options.length = 0;

                            //populate the employees select
                            var myObject = JSON.parse(result, null);
                            //debugObject(myObject['employees']);
                            //alert(myObject['employees'].length);

                            employeeSelect.options[0] = new Option('All employees', 'NULL');
                            var i = 1;
                            for(var k=0; k < myObject['employees'].length; k++){
                                //alert(myObject.employees[k]['name']);
                                employeeSelect.options[i] = new Option(myObject.employees[k]['name'], myObject.employees[k]['id']);
                                i++;
                            }
                            
                        } else {
                            //alert('Cannot access cross domain information.' + http);
                        }
                    }
                    //alert(params);
                    http.send(params);	
               }//if
           }
        </script>
        
    </head>
    <body onload="call_angajati()">
		<?php
			define('SECTION', 'reports');
			include_once("../common/header.php");
			include_once("../common/mainbar.php");
			print showErrorAndMessagesLogs();
		?>
    

<div class="current_date">Current date: &nbsp; <b><?=getDateAndTime()?></b><?=($displayReports == true) ? '| <a href="'. SERVER_ROOT .'/reports/project-reports.php?print=true&amp;projectId='. $projectId .'&amp;userId='. $userId .'&amp;startDate='. $startDate .'&amp;endDate='. $endDate .'" target="_blank" class="print_version"><img src="'. SERVER_ROOT .'/assets/images/print2.jpg" border="0" alt="Print this report" title="Print this report">Print this report</a>' : "" ?></div>
<hr />

<? if($print != true) { ?>           
        <div class="page_title">Project reports</div> 
        
        <form action="<?=SERVER_ROOT?>/common/controller.php" method="post">
            <input type="hidden" name="action" value="doDisplayProjectReportExe"/>
            <table cellpadding="0" cellspacing="3" class="form_style">
                <tr>

                    <th><label for="projectId">Project</label></th>
                    <td>(<span class="required_field" title="Mandatory field">*</span>)</td>
                    <td>
                        <select name="projectId" id="projectId" onchange="call_angajati()">  
                            <option value="NULL">Select a project</option>
                            <?
                            	$projects = $delegate->getProjects();
                            	if(count($projects > 0)) {
                            		foreach($projects as $projectKey => $project) {
                            			?>
											<option value="<?=$project->id?>" <?=($tmpProjectReports->projectId == $project->id ? 'selected="selected"' : void())?>><?=$project->name?></option>                            			
                            			<?
                            		}
                            	}
                            ?>
                        </select>
                    </td>
                </tr>

                <tr>
                    <th><label for="angajatId">Employees</label> </th>
                    <td>&nbsp;</td>

                    <td>
                         <select name="angajatId" id="angajatId">                      
                            <option value="0">Selecteaza angajat</option>
                            
                        </select>
                    </td>
                </tr>
                        
                <tr>
                    <th><label for="period">Period of time</label></th>

                    <td>(<span class="required_field" title="Mandatory field">*</span>)</td>
                    <td>
                        <select id="period" name="period" onchange="pickPeriod()">
                            <option value="0">Select period of time</option>
                            
                            <option value="currentMonth">Current month</option>
                            <option value="lastMonth">Last month</option>

                        </select>
                    </td> 
                </tr> 
                
                <tr>
                    <th><label for="periodStart">Start date<br/><span class="date_format_tip">[dd/mm/yyyy]</span></label></th>
                    <td>&nbsp;</td>
                    <td>
                        <input style="width:211px;" type="text" name="periodStart" id="periodStart" value="<?=$tmpProjectReports->startDate?>">
                    </td>

                    <td>           
                        <input type="image" src="<?=SERVER_ROOT?>/assets/calendar/img.gif" id="periodStartTrigger">
                        <?=calendarSetup('periodStart', '%d/%m/%Y', 24, 'false', 'periodStartTrigger', 'false', 1)?>
                    </td> 
                </tr> 
                
                <tr>
                    <th><label for="periodEnd">End date<br/><span class="date_format_tip">[dd/mm/yyyy]</span></label></th>
                    <td>&nbsp;</td>
                    <td>

                        <input style="width:211px;" type="text" name="periodEnd" id="periodEnd" value="<?=$tmpProjectReports->endDate?>">
                    </td>
                    <td>                             
                        <input type="image" src="<?=SERVER_ROOT?>/assets/calendar/img.gif" id="periodEndTrigger">
                        <?=calendarSetup('periodEnd', '%d/%m/%Y', 24, 'false', 'periodEndTrigger', 'false', 1)?>
                    </td> 
               </tr> 
               
              <tr>
                <td>&nbsp;</td>
                <td>&nbsp;</td>

                <td align="right">
                    <a href="<?=SERVER_ROOT?>/common/controller.php?action=goToReports" class="cancel_action">cancel</a>
                    <input type="submit" value="Submit" class="submit_button">
                </td>
                <td>&nbsp;</td>
             </tr>
             
             <tr>
                <td class="required_field_info"><span class="required_field" title="Mandatory field">*</span>&nbsp;mandatory field</td>

            </tr>
             
           </table>
        </form>
        
<?
}

if(is_numeric($projectId) AND !empty($startDate) AND !empty($endDate)) {
	
	$projects		=	$delegate->getProjects(array('id' => $projectId, '__orderby' => 'project_name'));
	if(count($projects) == 1) {
		foreach($projects as $projectKey => $project);	
	}
	
	$intStartDate	=	strtotime($startDate);
	$intEndDate		=	strtotime($endDate);
	
	$daysNo = (($intEndDate-$intStartDate)/86400+1);
	
}
?>

<!-- START : DISPLAY REPORTS -->

<? if(false) { ?>
	<div class="page_title">Project reports (<?=date("M d, Y", strtotime($startDate))?> - <?=date("M d, Y", strtotime($endDate))?>)</div> 
	<div class="page_title" style="font-size:14px;">Project: <?=$project->name?></div>
	 
	<table cellpadding="7" cellspacing="0" class="list_something">

		<tr>
			<th>Day</th>
			<th>Date</th>
			<th>Project</th>
			<th>Task</th>
			<th>Start</th>
			<th>End</th>
			<th>Duration</th>
			<th>Description</th>
			<th>Entry status</th>
			<th><span class="not_finished_exclamation" title="Unfinished task">!</span></th>
			<th><span class="not_finished_exclamation"><img src="<?=SERVER_ROOT?>/assets/images/reject_reason.gif" width="14" height="15" alt="Reject entry reason" title="Reject entry reason" /></span></th>
			<th><span class="not_finished_exclamation"><img src="<?=SERVER_ROOT?>/assets/images/info_pontaj_special_bgr.gif" alt="Task info" title="Task info"/></span></th>
		</tr>
		

<? }
###############################################################################
###############################################################################
if(!empty($startDate) AND !empty($endDate)) {
	
	list($startDateDay,	$startDateMonth, $startDateYear)	=	explode("/", $startDate);
	list($endDateDay,	$endDateMonth,   $endDateYear)		=	explode("/", $endDate);
	
	$timeEndDate	=	strtotime(str_replace("/", "-", $endDate));
	$timeStartDate	=	strtotime(str_replace("/", "-", $startDate));
	$daysNo = (($timeEndDate-$timeStartDate)/86400+1);
	
	// If userId is set
	if(is_numeric($userId) AND $userId > 0) { 
		$users = $delegate->getUsers(array('id' => $userId));
	
	
	// Else, get all users for this project
	} else {
		
		// Get all users in that projects
		//$usersInProject = $delegate->getUsersInProjects(array("projectid" => $projectId));
		$usersInProject = $delegate->getUsersInProjectsOrderByUserName(array("projectid" => $projectId));
		
		// If exists users in that project
		if(count($usersInProject) > 0) {
			
			// For each loop
			foreach($usersInProject as $userInProjectKey => $userInProject) {
				
				// Get users by id
				$usersArray = $delegate->getUsers(array("id" => $userInProject->userId));
				
				// If user exists, save user object in new users[] array()
				if(count($usersArray) == 1) {
					$users[] = $usersArray[0];
				}
			}
			
			// Reorder users array()
			//sort($users); 
		}
		
	}

if(count($users) > 0) {
?>
        <div class="page_title">Project reports (<?=date("M d, Y", strtotime($startDate))?> - <?=date("M d, Y", strtotime($endDate))?>)</div>
        <div class="page_title" style="font-size:14px;">Project: <?=$project->name?></div> 
        
        <table cellpadding="10" cellspacing="0" class="list_something">            
            <tr>
                <th rowspan="2">Date</th>
                <th colspan="<?=count($users)?>">Employees</th>
                <th rowspan="2">Total hours<br />for each day</th>
			</tr>
			
			<tr>
				<?
				foreach($users as $userKey => $user) {
							print "<th>{$user->name}</th>\n";
				}
				?>
			</tr>
			
			
			<?	
				$nextDayAndMonth = $timeStartDate;
				for($i = 1; $i<= $daysNo; $i++) {
			?>
				<tr>
					<td><?=date("Y-m-d", $nextDayAndMonth)?></td>
					<?
						$usersTotalTimeSpanForThisDate = 0;
						foreach($users as $userKey => $user) {
						
							$timeSpan = $delegate->computeUserTimeSpanByDateAndProject($user->id, date("Y-m-d", $nextDayAndMonth), $projectId); 
							if(is_numeric($timeSpan) AND $timeSpan > 0) {
								print "<td>". date("H:i", mktime(0, $timeSpan, 0, 0, 0, 0)) ."</td>\n";
								$usersTotalTimeSpanForThisDate += $timeSpan; 
								
							} else {
								print "<td>&nbsp;</td>";
							}
						}					
					?>
					<td><b><?=date("H:i", mktime(0, $usersTotalTimeSpanForThisDate, 0, 0, 0, 0))?></b></td>
				</tr>
			<?
				$nextDayAndMonth = $nextDayAndMonth + 86400;
				}
			?>
			
            <tr>
                <th rowspan="2">Total hours for<br /> each employee</th>
                <?	$totalTimeSpanForProject = 0;
                
                	foreach($users as $userKey => $user) {
                		
                		$totalTimeSpanForUser = $delegate->computeUserTimeSpanByDatesAndProject($user->id, date("Y-m-d", $timeStartDate), date("Y-m-d", $timeEndDate), $projectId);
                		$totalTimeSpanForProject += $totalTimeSpanForUser;
                		
                		if(is_numeric($totalTimeSpanForUser) AND $totalTimeSpanForUser > 0) {
							print "<td><b>". floor($totalTimeSpanForUser/60) .":". $totalTimeSpanForUser%60 ."</b></td>\n";
								
						} else {
							print "<td><b>00:00</b></th>\n";
						}
                	}
                ?>
                <th>Total hours for<br />project: <?=floor($totalTimeSpanForProject/60) .":". $totalTimeSpanForProject%60?></th>
			</tr>
			
		</table>
<? }
} else {
	?>
	No employees for this project!
	<?
}

###############################################################################
###############################################################################
        
if($print == false) { ?>
		<!-- FOOTER -->
        <?include_once("../common/footer.php");?>
        
<? } ?>
    </body>
</html>