<?php
/**
 * Get all projects (id and name) by user id
 * 
 * @author	Liviu
 * @since 	Apr 8, 2008 
 */

// Set headers 
header('Content-type: text/plain'); 

// Include needed files
include('./JSON.php');
include('./delegate.php');

// Collect data from REQUEST
$userId		= $_REQUEST['employeeId'];

// Make new Delegate instance
$delegate	= new Delegate();

// Get all user in project
//$userInProjects = $delegate->getUsersInProjects(array("userid" => $userId));
$userInProjects = $delegate->getUsersInProjectsOrderByProjectName(array('userid' => $userId));

$projectsArray = array();

// User is in at least one project
if(count($userInProjects) > 0) {
	
	// For each loop
	foreach($userInProjects as $userInProjectKey => $userInProject) {
		
		// Get project by id
		$projects = $delegate->getProjects(array('id' => $userInProject->projectId));
		
		// If project exists
		if(count($projects) == 1) {
			
			// For each loop
			foreach($projects as $projectKey => $project) {
				
				// Add in array id and project name
				$projectsArray[] = array('id' => $project->id, 'name' => $project->name);
			}
		}	
	}
}

// Make the final map
$finalMap = array('projects'=>$projectsArray);

// Make new JSon instance
$json = new Services_JSON();

// Make the final output
$output = $json->encode($finalMap);

// Print the output      
print($output);

?> 